/*---------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
"use strict";var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n},__decorate=this&&this.__decorate||function(e,t,n,r){if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)return Reflect.decorate(e,t,n,r);switch(arguments.length){case 2:return e.reduceRight(function(e,t){return t&&t(e)||e},t);case 3:return e.reduceRight(function(e,r){return r&&r(t,n),void 0},void 0);case 4:return e.reduceRight(function(e,r){return r&&r(t,n,e)||e},r)}},__param=this&&this.__param||function(e,t){return function(n,r){t(n,r,e)}};define("vs/workbench/parts/git/browser/gitActions",["require","exports","vs/base/common/winjs.base","vs/nls!vs/workbench/parts/git/browser/gitViewlet","vs/base/common/lifecycle","vs/base/common/strings","vs/base/common/types","vs/base/common/actions","vs/workbench/parts/git/common/git","vs/workbench/parts/git/common/gitModel","vs/workbench/parts/git/browser/gitEditorInputs","vs/workbench/common/editor","vs/base/common/errors","vs/base/common/platform","vs/workbench/services/editor/common/editorService","vs/platform/event/common/event","vs/platform/files/common/files","vs/platform/message/browser/message"],function(e,t,n,r,i,o,a,s,c,l,u,p,d,m,h,f,g,v){function y(e,t){if(void 0===t&&(t=!1),e){if(Array.isArray(e)){if(e.some(function(e){return!(e instanceof l.FileStatus)}))throw new Error("Invalid context.");return e}if(e instanceof l.FileStatus)return[e];if(e instanceof l.StatusGroup)return e.all();if(e.tree){var n=e.tree.getSelection();return n.indexOf(e.fileStatus)>-1?n:[e.fileStatus]}if(e.selection)return!t&&e.selection.indexOf(e.focus)>-1?e.selection:[e.focus];throw new Error("Invalid context.")}return e}var _=c.IGitService,b=function(e){function t(t,n,r,i){var o=this;this.gitService=i,e.call(this,t,n,r,!1),this.toDispose=[this.gitService.addBulkListener2(function(){return o.onGitServiceChange()})],this.onGitServiceChange()}return __extends(t,e),t.prototype.onGitServiceChange=function(){this.updateEnablement()},t.prototype.updateEnablement=function(){this.enabled=this.isEnabled()},t.prototype.isEnabled=function(){return!!this.gitService},t.prototype.run=function(){throw new Error("implement me")},t.prototype.dispose=function(){this.gitService=null,this.toDispose=i.disposeAll(this.toDispose),e.prototype.dispose.call(this)},t}(s.Action);t.AbstractGitAction=b;var E=function(e){function t(n,i){this.editorService=n,e.call(this,t.ID,r.localize("vs_workbench_parts_git_browser_gitActions",0),"git-action open-change",i)}return __extends(t,e),t.prototype.isEnabled=function(){return e.prototype.isEnabled.call(this)&&!!this.editorService},t.prototype.run=function(e){var t=this,n=y(e,!0);return this.gitService.getInput(n[0]).then(function(e){var n=new p.TextDiffEditorOptions;return n.forceOpen=!0,t.editorService.openEditor(e,n)})},t.ID="workbench.git.action.openChange",t=__decorate([__param(0,h.IWorkbenchEditorService),__param(1,_)],t)}(b);t.OpenChangeAction=E;var T=function(e){function t(n,i,o){this.fileService=i,this.editorService=n,e.call(this,t.ID,r.localize("vs_workbench_parts_git_browser_gitActions",1),"git-action open-file",o)}return __extends(t,e),t.prototype.isEnabled=function(){return e.prototype.isEnabled.call(this)&&!!this.editorService||!!this.fileService},t.prototype.getPath=function(e){if(e.getStatus()===c.Status.INDEX_RENAMED)return e.getRename();var t=this.gitService.getModel().getStatus().find(e.getPath(),c.StatusType.INDEX);return t&&t.getStatus()===c.Status.INDEX_RENAMED?e.getRename():e.getPath()},t.prototype.run=function(e){var r=this,i=y(e,!0),o=i[0];if(!(o instanceof l.FileStatus))return n.Promise.wrapError(new Error("Can't open file."));if(t.DELETED_STATES.indexOf(o.getStatus())>-1)return n.Promise.wrapError(new Error("Can't open file which is has been deleted."));var a=this.getPath(o);return this.fileService.resolveFileStat(a).then(function(e){return r.editorService.openEditor({resource:e.resource,mime:e.mime,options:{forceOpen:!0}})})},t.DELETED_STATES=[c.Status.BOTH_DELETED,c.Status.DELETED,c.Status.DELETED_BY_US,c.Status.INDEX_DELETED],t.ID="workbench.git.action.openFile",t=__decorate([__param(0,h.IWorkbenchEditorService),__param(1,g.IFileService),__param(2,_)],t)}(b);t.OpenFileAction=T;var S=function(e){function t(n){e.call(this,t.ID,r.localize("vs_workbench_parts_git_browser_gitActions",2),"git-action init",n)}return __extends(t,e),t.prototype.isEnabled=function(){return e.prototype.isEnabled.call(this)&&this.gitService.getState()===c.ServiceState.NotARepo},t.prototype.run=function(){return this.gitService.init()},t.ID="workbench.git.action.init",t=__decorate([__param(0,_)],t)}(b);t.InitAction=S;var k=function(e){function t(n){e.call(this,t.ID,r.localize("vs_workbench_parts_git_browser_gitActions",3),"git-action refresh",n)}return __extends(t,e),t.prototype.run=function(){return this.gitService.status()},t.ID="workbench.git.action.refresh",t=__decorate([__param(0,_)],t)}(b);t.RefreshAction=k;var C=function(e){function t(t,n,r,i,o){e.call(this,t,n,r,i),this.editorService=o}return __extends(t,e),t.prototype.run=function(e){var t=this,r=y(e);return this.gitService.add(y(e)).then(function(e){var i=t.findGitWorkingTreeEditor();if(!i)return n.Promise.as(e);var o=i.input,a=o.getFileStatus();if(r&&r.every(function(e){return e!==a}))return n.Promise.as(e);var s=o.getFileStatus().getPath(),l=e.getStatus().find(s,c.StatusType.INDEX);if(!l)return n.Promise.as(e);var u=i.getControl(),d=u?u.saveViewState():null;return t.gitService.getInput(l).then(function(n){var r=new p.TextDiffEditorOptions;return r.forceOpen=!0,t.editorService.openEditor(n,r,i.position).then(function(){return d&&u.restoreViewState(d),e})})})},t.prototype.findGitWorkingTreeEditor=function(){for(var e=this.editorService.getVisibleEditors(),t=0;t<e.length;t++){var n=e[t];if(u.isGitEditorInput(n.input))return n}return null},t.prototype.dispose=function(){this.editorService=null,e.prototype.dispose.call(this)},t}(b);t.AbstractStageAction=C;var w=function(e){function t(n,r){e.call(this,t.ID,t.LABEL,"git-action stage",n,r)}return __extends(t,e),t.ID="workbench.git.action.stage",t.LABEL=r.localize("vs_workbench_parts_git_browser_gitActions",4),t=__decorate([__param(0,_),__param(1,h.IWorkbenchEditorService)],t)}(C);t.StageAction=w;var x=function(e){function t(n,i){e.call(this,t.ID,r.localize("vs_workbench_parts_git_browser_gitActions",5),"git-action stage",n,i)}return __extends(t,e),t.prototype.isEnabled=function(){return e.prototype.isEnabled.call(this)&&this.gitService.getModel().getStatus().getWorkingTreeStatus().all().length>0},t.prototype.run=function(){return e.prototype.run.call(this)},t.ID="workbench.git.action.stageAll",t=__decorate([__param(0,_),__param(1,h.IWorkbenchEditorService)],t)}(C);t.GlobalStageAction=x;var A=function(e){function t(t,n,r,i,o,a,s,c){this.eventService=o,this.editorService=c,this.messageService=a,this.fileService=s,e.call(this,t,n,r,i)}return __extends(t,e),t.prototype.isEnabled=function(){return e.prototype.isEnabled.call(this)&&!!this.eventService&&!!this.editorService&&!!this.fileService},t.prototype.run=function(e){var t=this;if(!this.messageService.confirm(this.getConfirm(e)))return n.Promise.as(null);var r=[];if(e instanceof l.StatusGroup)r=[this.gitService.undo()];else{for(var i=y(e),o=[],a=[],s=0;s<i.length;s++){var u=i[s].clone();switch(u.getStatus()){case c.Status.UNTRACKED:case c.Status.IGNORED:o.push(u);break;default:a.push(u)}}o.length>0&&r.push(this.gitService.clean(o)),a.length>0&&r.push(this.gitService.checkout("",a))}return n.Promise.join(r).then(function(e){if(0===e.length)return n.Promise.as(null);var r=e[e.length-1],o=t.findWorkingTreeDiffEditor();if(!o)return n.Promise.as(r);var a=o.input,s=a.getFileStatus();if(i&&i.every(function(e){return e!==s}))return n.Promise.as(r);var c=a.getFileStatus().getPath(),l=o.getControl(),u=l?l.getModifiedEditor():null,p=u?u.saveViewState():null;return t.fileService.resolveFileStat(c).then(function(e){return t.editorService.openEditor({resource:e.resource,mime:e.mime,options:{forceOpen:!0}},o.position).then(function(){if(p){var e=o.getControl();e&&e.restoreViewState(p)}})})}).then(null,function(e){return console.error("One or more errors occured",e),n.Promise.wrapError(e[0])})},t.prototype.findWorkingTreeDiffEditor=function(){for(var e=this.editorService.getVisibleEditors(),t=0;t<e.length;t++){var n=e[t];if(n.input instanceof u.GitWorkingTreeDiffEditorInput)return n}return null},t.prototype.getConfirm=function(e){var t=y(e);if(t.length>1){var n=t.length;return{message:r.localize("vs_workbench_parts_git_browser_gitActions",6),detail:1===n?r.localize("vs_workbench_parts_git_browser_gitActions",7,n):r.localize("vs_workbench_parts_git_browser_gitActions",8,n),primaryButton:r.localize("vs_workbench_parts_git_browser_gitActions",9)}}var i=t[0].getPathComponents().reverse()[0];return{message:r.localize("vs_workbench_parts_git_browser_gitActions",10,i),primaryButton:r.localize("vs_workbench_parts_git_browser_gitActions",11)}},t.prototype.dispose=function(){this.eventService=null,this.editorService=null,this.fileService=null,e.prototype.dispose.call(this)},t}(b);t.AbstractUndoAction=A;var L=function(e){function t(n,i,o,a,s){e.call(this,t.ID,r.localize("vs_workbench_parts_git_browser_gitActions",12),"git-action undo",n,i,o,a,s)}return __extends(t,e),t.ID="workbench.git.action.undo",t=__decorate([__param(0,_),__param(1,f.IEventService),__param(2,v.IMessageService),__param(3,g.IFileService),__param(4,h.IWorkbenchEditorService)],t)}(A);t.UndoAction=L;var N=function(e){function t(n,i,o,a,s){e.call(this,t.ID,r.localize("vs_workbench_parts_git_browser_gitActions",13),"git-action undo",n,i,o,a,s)}return __extends(t,e),t.prototype.isEnabled=function(){return e.prototype.isEnabled.call(this)&&this.gitService.getModel().getStatus().getWorkingTreeStatus().all().length>0},t.prototype.run=function(){return e.prototype.run.call(this,this.gitService.getModel().getStatus().getWorkingTreeStatus())},t.ID="workbench.git.action.undoAll",t=__decorate([__param(0,_),__param(1,f.IEventService),__param(2,v.IMessageService),__param(3,g.IFileService),__param(4,h.IWorkbenchEditorService)],t)}(A);t.GlobalUndoAction=N;var P=function(e){function t(t,n,r,i,o){e.call(this,t,n,r,i),this.editorService=o}return __extends(t,e),t.prototype.isEnabled=function(){return e.prototype.isEnabled.call(this)&&!!this.editorService},t.prototype.run=function(e){var t=this,r=y(e);return this.gitService.reset("HEAD",r).then(function(e){var i=t.findGitIndexEditor();if(!i)return n.Promise.as(e);var o=i.input,a=o.getFileStatus();if(r&&r.every(function(e){return e!==a}))return n.Promise.as(e);var s=o.getFileStatus().getPath(),l=e.getStatus().find(s,c.StatusType.WORKING_TREE);if(!l)return n.Promise.as(e);var u=i.getControl(),d=u?u.saveViewState():null;return t.gitService.getInput(l).then(function(n){var r=new p.TextDiffEditorOptions;return r.forceOpen=!0,t.editorService.openEditor(n,r,i.position).then(function(){return d&&u.restoreViewState(d),e})})})},t.prototype.findGitIndexEditor=function(){for(var e=this.editorService.getVisibleEditors(),t=0;t<e.length;t++){var n=e[t];if(u.isGitEditorInput(n.input))return n}return null},t.prototype.dispose=function(){this.editorService=null,e.prototype.dispose.call(this)},t}(b);t.AbstractUnstageAction=P;var O=function(e){function t(n,i){e.call(this,t.ID,r.localize("vs_workbench_parts_git_browser_gitActions",14),"git-action unstage",n,i)}return __extends(t,e),t.ID="workbench.git.action.unstage",t=__decorate([__param(0,_),__param(1,h.IWorkbenchEditorService)],t)}(P);t.UnstageAction=O;var I=function(e){function t(n,i){e.call(this,t.ID,r.localize("vs_workbench_parts_git_browser_gitActions",15),"git-action unstage",n,i)}return __extends(t,e),t.prototype.isEnabled=function(){return e.prototype.isEnabled.call(this)&&this.gitService.getModel().getStatus().getIndexStatus().all().length>0},t.prototype.run=function(){return e.prototype.run.call(this)},t.ID="workbench.git.action.unstageAll",t=__decorate([__param(0,_),__param(1,h.IWorkbenchEditorService)],t)}(P);t.GlobalUnstageAction=I;var M;!function(e){e[e.Alive=0]="Alive",e[e.Disposing=1]="Disposing",e[e.Disposed=2]="Disposed"}(M||(M={}));var R=function(e){function t(n,r,i){this.editorService=i,this.branch=n,this.HEAD=null,this.state=M.Alive,this.runPromises=[],e.call(this,t.ID,n.name,"git-action checkout",r)}return __extends(t,e),t.prototype.onGitServiceChange=function(){this.gitService.getState()===c.ServiceState.OK&&(this.HEAD=this.gitService.getModel().getHEAD(),this.class=this.HEAD&&this.HEAD.name===this.branch.name?"git-action checkout HEAD":"git-action checkout"),e.prototype.onGitServiceChange.call(this)},t.prototype.isEnabled=function(){return e.prototype.isEnabled.call(this)&&!!this.HEAD},t.prototype.run=function(){var e=this;if(this.state!==M.Alive)return n.Promise.wrapError("action disposed");if(this.HEAD&&this.HEAD.name===this.branch.name)return n.Promise.as(null);var t=this.gitService.checkout(this.branch.name).then(null,function(e){return e.gitErrorCode===c.GitErrorCodes.DirtyWorkTree?n.Promise.wrapError(new Error(r.localize("vs_workbench_parts_git_browser_gitActions",16))):n.Promise.wrapError(e)});return this.runPromises.push(t),t.done(function(){return e.runPromises.splice(e.runPromises.indexOf(t),1)}),t},t.prototype.dispose=function(){var e=this;this.state===M.Alive&&(this.state=M.Disposing,n.Promise.join(this.runPromises).done(function(){return e.actuallyDispose()}))},t.prototype.actuallyDispose=function(){this.editorService=null,this.branch=null,this.HEAD=null,e.prototype.dispose.call(this),this.state=M.Disposed},t.ID="workbench.git.action.checkout",t=__decorate([__param(1,_),__param(2,h.IWorkbenchEditorService)],t)}(b);t.CheckoutAction=R;var D=function(e){function t(n,i){e.call(this,t.ID,r.localize("vs_workbench_parts_git_browser_gitActions",17),"git-action checkout",i),this.checkout=n}return __extends(t,e),t.prototype.run=function(e){return a.isString(e)?this.gitService.branch(e,this.checkout):n.Promise.as(!1)},t.ID="workbench.git.action.branch",t=__decorate([__param(1,_)],t)}(b);t.BranchAction=D;var V=function(e){function t(t,n,r,i,o){var a=this;e.call(this,n,r,i,o),this.commitState=t,this.toDispose.push(t.addListener2("change/commitInputBox",function(){a.updateEnablement()}))}return __extends(t,e),t.prototype.isEnabled=function(){return e.prototype.isEnabled.call(this)&&this.gitService.getModel().getStatus().getIndexStatus().all().length>0},t.prototype.run=function(){return this.commitState.getCommitMessage()?this.gitService.commit(this.commitState.getCommitMessage()):(this.commitState.onEmptyCommitMessage(),n.Promise.as(null))},t}(b);t.AbstractCommitAction=V;var F=function(e){function t(n,i){e.call(this,n,t.ID,r.localize("vs_workbench_parts_git_browser_gitActions",18),"git-action commit",i)}return __extends(t,e),t.ID="workbench.git.action.commit",t=__decorate([__param(1,_)],t)}(V);t.CommitAction=F;var B=function(e){function t(n,i){e.call(this,n,t.ID,r.localize("vs_workbench_parts_git_browser_gitActions",19),"git-action stage-and-commit",i)}return __extends(t,e),t.prototype.isEnabled=function(){if(!this.gitService)return!1;if(!this.gitService.isIdle())return!1;var e=this.gitService.getModel().getStatus();return e.getIndexStatus().all().length>0||e.getWorkingTreeStatus().all().length>0},t.prototype.run=function(){return this.commitState.getCommitMessage()?this.gitService.commit(this.commitState.getCommitMessage(),!1,!0):(this.commitState.onEmptyCommitMessage(),n.Promise.as(null))},t.ID="workbench.git.action.stageAndCommit",t=__decorate([__param(1,_)],t)}(V);t.StageAndCommitAction=B;var $=function(e){function t(n,r,i){this.messageService=i,e.call(this,n,t.ID,t.ALL,"git-action smart-commit",r)}return __extends(t,e),t.prototype.onGitServiceChange=function(){if(e.prototype.onGitServiceChange.call(this),!this.enabled)return this.label=t.ALL,void 0;var n=this.gitService.getModel().getStatus();this.label=n.getIndexStatus().all().length>0?t.STAGED:t.ALL,this.label+=" ("+(m.isMacintosh?"Cmd+Enter":"Ctrl+Enter")+")"},t.prototype.isEnabled=function(){if(!this.gitService)return!1;if(!this.gitService.isIdle())return!1;var e=this.gitService.getModel().getStatus();return e.getIndexStatus().all().length>0||e.getWorkingTreeStatus().all().length>0},t.prototype.run=function(){if(!this.commitState.getCommitMessage())return this.commitState.onEmptyCommitMessage(),n.Promise.as(null);var e=this.gitService.getModel().getStatus();return this.gitService.commit(this.commitState.getCommitMessage(),!1,0===e.getIndexStatus().all().length)},t.ID="workbench.git.action.commitAll",t.ALL=r.localize("vs_workbench_parts_git_browser_gitActions",20),t.STAGED=r.localize("vs_workbench_parts_git_browser_gitActions",21),t=__decorate([__param(1,_),__param(2,v.IMessageService)],t)}(V);t.SmartCommitAction=$;var j=function(e){function t(n){e.call(this,t.ID,r.localize("vs_workbench_parts_git_browser_gitActions",22),"git-action pull",n)}return __extends(t,e),t.prototype.isEnabled=function(){if(!e.prototype.isEnabled.call(this))return!1;if(!this.gitService.isIdle())return!1;var t=this.gitService.getModel(),n=t.getHEAD();return n&&n.name&&n.upstream?!0:!1},t.prototype.run=function(){return this.gitService.pull().then(null,function(e){return e.gitErrorCode===c.GitErrorCodes.DirtyWorkTree?n.Promise.wrapError(new Error(r.localize("vs_workbench_parts_git_browser_gitActions",23))):e.gitErrorCode===c.GitErrorCodes.AuthenticationFailed?n.Promise.wrapError(d.error(r.localize("vs_workbench_parts_git_browser_gitActions",24))):n.Promise.wrapError(e)})},t.ID="workbench.git.action.pull",t=__decorate([__param(0,_)],t)}(b);t.PullAction=j;var U=function(e){function t(n){e.call(this,t.ID,r.localize("vs_workbench_parts_git_browser_gitActions",25),"git-action push",n)}return __extends(t,e),t.prototype.isEnabled=function(){if(!e.prototype.isEnabled.call(this))return!1;if(!this.gitService.isIdle())return!1;var t=this.gitService.getModel(),n=t.getHEAD();return n&&n.name&&n.upstream?n.ahead?!0:!1:!1},t.prototype.run=function(){return this.gitService.push().then(null,function(e){return e.gitErrorCode===c.GitErrorCodes.AuthenticationFailed?n.Promise.wrapError(d.error(r.localize("vs_workbench_parts_git_browser_gitActions",26))):n.Promise.wrapError(e)})},t.ID="workbench.git.action.push",t=__decorate([__param(0,_)],t)}(b);t.PushAction=U;var G=function(e){function t(t,n,r,i){e.call(this,t,n,r,i)}return __extends(t,e),t.prototype.isEnabled=function(){if(!e.prototype.isEnabled.call(this))return!1;if(!this.gitService.isIdle())return!1;var t=this.gitService.getModel(),n=t.getHEAD();return n&&n.name&&n.upstream?!0:!1},t.prototype.run=function(){return this.enabled?this.gitService.sync().then(null,function(e){return e.gitErrorCode===c.GitErrorCodes.AuthenticationFailed?n.Promise.wrapError(d.error(r.localize("vs_workbench_parts_git_browser_gitActions",27))):n.Promise.wrapError(e)}):n.Promise.as(null)},t}(b);t.AbstractSyncAction=G;var H=function(e){function t(n){e.call(this,t.ID,r.localize("vs_workbench_parts_git_browser_gitActions",28),"git-action sync",n)}return __extends(t,e),t.ID="workbench.git.action.sync",t=__decorate([__param(0,_)],t)}(G);t.SyncAction=H;var z=function(e){function t(n){e.call(this,t.ID,r.localize("vs_workbench_parts_git_browser_gitActions",29),t.CLASS_NAME,n)}return __extends(t,e),t.prototype.onGitServiceChange=function(){if(e.prototype.onGitServiceChange.call(this),this.gitService.getRunningOperations().some(function(e){return e.id===c.ServiceOperations.SYNC||e.id===c.ServiceOperations.PULL||e.id===c.ServiceOperations.PUSH}))this.label="",this.class=t.CLASS_NAME_LOADING,this.tooltip=r.localize("vs_workbench_parts_git_browser_gitActions",30);else{this.class=t.CLASS_NAME;var n=this.gitService.getModel(),i=n.getHEAD();i?i.name?i.upstream?i.ahead||i.behind?(this.label=o.format("{0}↓ {1}↑",i.behind,i.ahead),this.tooltip=n.getStatus().getGroups().some(function(e){return e.all().length>0})?r.localize("vs_workbench_parts_git_browser_gitActions",34):1===i.behind&&1===i.ahead?r.localize("vs_workbench_parts_git_browser_gitActions",35,i.name,i.behind,i.ahead,i.upstream):1===i.behind?r.localize("vs_workbench_parts_git_browser_gitActions",36,i.name,i.behind,i.ahead,i.upstream):1===i.ahead?r.localize("vs_workbench_parts_git_browser_gitActions",37,i.name,i.behind,i.ahead,i.upstream):r.localize("vs_workbench_parts_git_browser_gitActions",38,i.name,i.behind,i.ahead,i.upstream)):(this.label="",this.tooltip=r.localize("vs_workbench_parts_git_browser_gitActions",33,i.name)):(this.label="",this.tooltip=r.localize("vs_workbench_parts_git_browser_gitActions",32,i.name)):(this.label="",this.tooltip=r.localize("vs_workbench_parts_git_browser_gitActions",31)):(this.label="",this.tooltip="")}},t.ID="workbench.git.action.liveSync",t.CLASS_NAME="git-action live-sync",t.CLASS_NAME_LOADING="git-action live-sync loading",t=__decorate([__param(0,_)],t)}(G);t.LiveSyncAction=z});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n},__decorate=this&&this.__decorate||function(e,t,n,r){if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)return Reflect.decorate(e,t,n,r);switch(arguments.length){case 2:return e.reduceRight(function(e,t){return t&&t(e)||e},t);case 3:return e.reduceRight(function(e,r){return r&&r(t,n),void 0},void 0);case 4:return e.reduceRight(function(e,r){return r&&r(t,n,e)||e},r)}},__param=this&&this.__param||function(e,t){return function(n,r){t(n,r,e)}};define("vs/workbench/parts/git/browser/views/changes/changesViewer",["require","exports","vs/base/common/winjs.base","vs/nls!vs/workbench/parts/git/browser/gitViewlet","vs/base/common/platform","vs/base/common/severity","vs/base/browser/dom","vs/base/common/comparers","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/countBadge/countBadge","vs/base/parts/tree/common/tree","vs/base/parts/tree/browser/treeDnd","vs/base/parts/tree/browser/treeDefaults","vs/workbench/parts/git/common/git","vs/workbench/parts/git/common/gitModel","vs/workbench/parts/git/browser/gitActions","vs/platform/contextview/browser/contextView","vs/platform/instantiation/common/instantiation","vs/platform/message/browser/message"],function(e,t,n,r,i,o,a,s,c,l,u,p,d,m,h,f,g,v,y){function _(e){return i.isWindows?e.replace(/\//g,"\\"):e}var b=m.IGitService,E=a.emmet,T=function(){function e(e){this.cache={},this.instantiationService=e}return e.prototype.getAction=function(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n];var r=this.cache[e.ID];return r||(t.unshift(e),r=this.cache[e.ID]=this.instantiationService.createInstance.apply(this.instantiationService,t)),r},e.prototype.dispose=function(){var e=this;Object.keys(this.cache).forEach(function(t){e.cache[t].dispose()}),this.cache=null},e}();t.ActionContainer=T;var S=function(){function e(){}return e.prototype.getId=function(e,t){if(t instanceof h.StatusModel)return"root";if(t instanceof h.StatusGroup){var n=t;switch(n.getType()){case m.StatusType.INDEX:return"index";case m.StatusType.WORKING_TREE:return"workingTree";case m.StatusType.MERGE:return"merge";default:throw new Error("Invalid group type")}}var r=t;return r.getId()},e.prototype.hasChildren=function(e,t){if(t instanceof h.StatusModel)return!0;if(t instanceof h.StatusGroup){var n=t;return n.all().length>0}},e.prototype.getChildren=function(e,t){if(t instanceof h.StatusModel){var r=t;return n.Promise.as(r.getGroups())}if(t instanceof h.StatusGroup){var i=t;return n.Promise.as(i.all())}return n.Promise.as([])},e.prototype.getParent=function(){return n.Promise.as(null)},e}();t.DataSource=S;var k=function(e){function t(t,n){e.call(this,t),this.gitService=n}return __extends(t,e),t.prototype.hasActions=function(e,t){return t instanceof h.FileStatus?!0:t instanceof h.StatusGroup&&t.all().length>0?!0:!1},t.prototype.getActions=function(e,t){return t instanceof h.StatusGroup?n.Promise.as(this.getActionsForGroupStatusType(t.getType())):n.Promise.as(this.getActionsForFileStatusType(t.getType()))},t.prototype.getActionsForFileStatusType=function(e){switch(e){case m.StatusType.INDEX:return[this.getAction(f.UnstageAction)];case m.StatusType.WORKING_TREE:return[this.getAction(f.UndoAction),this.getAction(f.StageAction)];case m.StatusType.MERGE:return[this.getAction(f.StageAction)];default:return[]}},t.prototype.getActionsForGroupStatusType=function(e){switch(e){case m.StatusType.INDEX:return[this.getAction(f.GlobalUnstageAction)];case m.StatusType.WORKING_TREE:return[this.getAction(f.GlobalUndoAction),this.getAction(f.GlobalStageAction)];case m.StatusType.MERGE:return[this.getAction(f.StageAction)];default:return[]}},t.prototype.hasSecondaryActions=function(e,t){return this.hasActions(e,t)},t.prototype.getSecondaryActions=function(e,t){var n=this;return this.getActions(e,t).then(function(e){if(t instanceof h.FileStatus){var r=t,i=r.getStatus();e.push(new c.Separator),i!==m.Status.DELETED&&i!==m.Status.INDEX_DELETED&&e.push(n.getAction(f.OpenFileAction)),e.push(n.getAction(f.OpenChangeAction))}return e.reverse(),e})},t.prototype.getActionItem=function(){return null},t=__decorate([__param(0,v.IInstantiationService),__param(1,b)],t)}(T);t.ActionProvider=k;var C=function(){function e(e,t,n){this.actionProvider=e,this.actionRunner=t,this.messageService=n}return e.prototype.getHeight=function(){return 24},e.prototype.getTemplateId=function(e,t){if(t instanceof h.StatusGroup)switch(t.getType()){case m.StatusType.INDEX:return"index";case m.StatusType.WORKING_TREE:return"workingTree";case m.StatusType.MERGE:return"merge"}if(t instanceof h.FileStatus)switch(t.getType()){case m.StatusType.INDEX:return"file:index";case m.StatusType.WORKING_TREE:return"file:workingTree";case m.StatusType.MERGE:return"file:merge"}return null},e.prototype.renderTemplate=function(t,n,r){return/^file:/.test(n)?this.renderFileStatusTemplate(e.templateIdToStatusType(n),r):this.renderStatusGroupTemplate(e.templateIdToStatusType(n),r)},e.prototype.renderStatusGroupTemplate=function(e,t){var n=this,i=Object.create(null);switch(i.actionBar=new c.ActionBar(t,{actionRunner:this.actionRunner}),i.actionBar.push(this.actionProvider.getActionsForGroupStatusType(e),{icon:!0,label:!1}),i.actionBar.addListener2("run",function(e){return e.error&&n.onError(e.error)}),i.count=new l.CountBadge(t),i.root=a.append(t,E(".status-group")),e){case m.StatusType.INDEX:i.root.textContent=r.localize("vs_workbench_parts_git_browser_views_changes_changesViewer",0);break;case m.StatusType.WORKING_TREE:i.root.textContent=r.localize("vs_workbench_parts_git_browser_views_changes_changesViewer",1);break;case m.StatusType.MERGE:i.root.textContent=r.localize("vs_workbench_parts_git_browser_views_changes_changesViewer",2)}return i},e.prototype.renderFileStatusTemplate=function(e,t){var n=this,r=Object.create(null);r.actionBar=new c.ActionBar(t,{actionRunner:this.actionRunner}),r.actionBar.push(this.actionProvider.getActionsForFileStatusType(e),{icon:!0,label:!1}),r.actionBar.addListener2("run",function(e){return e.error&&n.onError(e.error)}),r.root=a.append(t,E(".file-status")),r.status=a.append(r.root,E("span.status")),r.name=a.append(r.root,E("a.name.plain")),r.folder=a.append(r.root,E("span.folder"));var i=a.append(r.root,E("span.rename")),o=a.append(i,E("span.rename-arrow"));return o.textContent="←",r.renameName=a.append(i,E("span.rename-name")),r.renameFolder=a.append(i,E("span.rename-folder")),r},e.prototype.renderElement=function(t,n,r,i){/^file:/.test(r)?e.renderFileStatus(t,n,i):e.renderStatusGroup(n,i)},e.renderStatusGroup=function(e,t){t.actionBar.context=e,t.count.setCount(e.all().length)},e.renderFileStatus=function(t,n,r){r.actionBar.context={tree:t,fileStatus:n};var i=n.getStatus(),o=n.getRename(),a=n.getPath(),s=a.lastIndexOf("/"),c=-1===s?a:a.substr(s+1,a.length),l=-1===s?"":a.substr(0,s);if(r.root.className="file-status "+e.statusToClass(i),r.status.textContent=e.statusToChar(i),r.status.title=e.statusToTitle(i),o){var u=o.lastIndexOf("/"),p=-1===u?o:o.substr(u+1,o.length),d=-1===u?"":o.substr(0,u);r.renameName.textContent=c,r.renameFolder.textContent=l}r.name.textContent=p||c,r.folder.textContent=_(d||l)},e.prototype.disposeTemplate=function(t,n,r){/^file:/.test(n)&&e.disposeFileStatusTemplate(r)},e.disposeFileStatusTemplate=function(e){e.actionBar.dispose()},e.statusToChar=function(e){switch(e){case m.Status.INDEX_MODIFIED:return r.localize("vs_workbench_parts_git_browser_views_changes_changesViewer",3);case m.Status.MODIFIED:return r.localize("vs_workbench_parts_git_browser_views_changes_changesViewer",4);case m.Status.INDEX_ADDED:return r.localize("vs_workbench_parts_git_browser_views_changes_changesViewer",5);case m.Status.INDEX_DELETED:return r.localize("vs_workbench_parts_git_browser_views_changes_changesViewer",6);case m.Status.DELETED:return r.localize("vs_workbench_parts_git_browser_views_changes_changesViewer",7);case m.Status.INDEX_RENAMED:return r.localize("vs_workbench_parts_git_browser_views_changes_changesViewer",8);case m.Status.INDEX_COPIED:return r.localize("vs_workbench_parts_git_browser_views_changes_changesViewer",9);case m.Status.UNTRACKED:return r.localize("vs_workbench_parts_git_browser_views_changes_changesViewer",10);case m.Status.IGNORED:return r.localize("vs_workbench_parts_git_browser_views_changes_changesViewer",11);case m.Status.BOTH_DELETED:return r.localize("vs_workbench_parts_git_browser_views_changes_changesViewer",12);case m.Status.ADDED_BY_US:return r.localize("vs_workbench_parts_git_browser_views_changes_changesViewer",13);case m.Status.DELETED_BY_THEM:return r.localize("vs_workbench_parts_git_browser_views_changes_changesViewer",14);case m.Status.ADDED_BY_THEM:return r.localize("vs_workbench_parts_git_browser_views_changes_changesViewer",15);case m.Status.DELETED_BY_US:return r.localize("vs_workbench_parts_git_browser_views_changes_changesViewer",16);case m.Status.BOTH_ADDED:return r.localize("vs_workbench_parts_git_browser_views_changes_changesViewer",17);case m.Status.BOTH_MODIFIED:return r.localize("vs_workbench_parts_git_browser_views_changes_changesViewer",18);default:return""}},e.statusToTitle=function(e){switch(e){case m.Status.INDEX_MODIFIED:return r.localize("vs_workbench_parts_git_browser_views_changes_changesViewer",19);case m.Status.MODIFIED:return r.localize("vs_workbench_parts_git_browser_views_changes_changesViewer",20);case m.Status.INDEX_ADDED:return r.localize("vs_workbench_parts_git_browser_views_changes_changesViewer",21);case m.Status.INDEX_DELETED:return r.localize("vs_workbench_parts_git_browser_views_changes_changesViewer",22);case m.Status.DELETED:return r.localize("vs_workbench_parts_git_browser_views_changes_changesViewer",23);case m.Status.INDEX_RENAMED:return r.localize("vs_workbench_parts_git_browser_views_changes_changesViewer",24);case m.Status.INDEX_COPIED:return r.localize("vs_workbench_parts_git_browser_views_changes_changesViewer",25);case m.Status.UNTRACKED:return r.localize("vs_workbench_parts_git_browser_views_changes_changesViewer",26);case m.Status.IGNORED:return r.localize("vs_workbench_parts_git_browser_views_changes_changesViewer",27);case m.Status.BOTH_DELETED:return r.localize("vs_workbench_parts_git_browser_views_changes_changesViewer",28);case m.Status.ADDED_BY_US:return r.localize("vs_workbench_parts_git_browser_views_changes_changesViewer",29);case m.Status.DELETED_BY_THEM:return r.localize("vs_workbench_parts_git_browser_views_changes_changesViewer",30);case m.Status.ADDED_BY_THEM:return r.localize("vs_workbench_parts_git_browser_views_changes_changesViewer",31);case m.Status.DELETED_BY_US:return r.localize("vs_workbench_parts_git_browser_views_changes_changesViewer",32);case m.Status.BOTH_ADDED:return r.localize("vs_workbench_parts_git_browser_views_changes_changesViewer",33);case m.Status.BOTH_MODIFIED:return r.localize("vs_workbench_parts_git_browser_views_changes_changesViewer",34);
default:return""}},e.statusToClass=function(e){switch(e){case m.Status.INDEX_MODIFIED:return"modified";case m.Status.MODIFIED:return"modified";case m.Status.INDEX_ADDED:return"added";case m.Status.INDEX_DELETED:return"deleted";case m.Status.DELETED:return"deleted";case m.Status.INDEX_RENAMED:return"renamed";case m.Status.INDEX_COPIED:return"copied";case m.Status.UNTRACKED:return"untracked";case m.Status.IGNORED:return"ignored";case m.Status.BOTH_DELETED:return"conflict both-deleted";case m.Status.ADDED_BY_US:return"conflict added-by-us";case m.Status.DELETED_BY_THEM:return"conflict deleted-by-them";case m.Status.ADDED_BY_THEM:return"conflict added-by-them";case m.Status.DELETED_BY_US:return"conflict deleted-by-us";case m.Status.BOTH_ADDED:return"conflict both-added";case m.Status.BOTH_MODIFIED:return"conflict both-modified";default:return""}},e.templateIdToStatusType=function(e){return/index$/.test(e)?m.StatusType.INDEX:/workingTree$/.test(e)?m.StatusType.WORKING_TREE:m.StatusType.MERGE},e.prototype.onError=function(e){this.messageService.show(o.Error,e)},e=__decorate([__param(2,y.IMessageService)],e)}();t.Renderer=C;var w=function(){function e(){}return e.prototype.isVisible=function(e,t){if(t instanceof h.StatusGroup){var n=t;switch(n.getType()){case m.StatusType.INDEX:case m.StatusType.MERGE:return n.all().length>0;case m.StatusType.WORKING_TREE:return!0}}return!0},e}();t.Filter=w;var x=function(){function e(){}return e.prototype.compare=function(t,n,r){return n instanceof h.FileStatus&&r instanceof h.FileStatus?e.compareStatus(n,r):0},e.compareStatus=function(e,t){for(var n,r,i,o,a=e.getPathComponents(),c=t.getPathComponents(),l=a.length-1,u=c.length-1,p=0;;p++){if(n=l===p,r=u===p,n&&r)return s.compareFileNames(a[p],c[p]);if(n)return-1;if(r)return 1;if((i=a[p].toLowerCase())!==(o=c[p].toLowerCase()))return o>i?-1:1}},e}();t.Sorter=x;var A=function(e){function t(t,n,r){e.call(this,t),this.gitService=n,this.messageService=r}return __extends(t,e),t.prototype.getDragURI=function(e,t){if(t instanceof h.StatusGroup){var n=t;return"git:"+n.getType()}if(t instanceof h.FileStatus){var r=t;return"git:"+r.getType()+":"+r.getPath()}return null},t.prototype.onDragStart=function(){},t.prototype.onDragOver=function(e,t,n){if(!this.gitService.isIdle())return u.DRAG_OVER_REJECT;if(!(t instanceof p.ElementsDragAndDropData))return u.DRAG_OVER_REJECT;var r=t.getData(),i=r[0];if(i instanceof h.StatusGroup){var o=i;return this.onDrag(n,o.getType())}if(i instanceof h.FileStatus){var a=i;return this.onDrag(n,a.getType())}return u.DRAG_OVER_REJECT},t.prototype.onDrag=function(e,t){return t===m.StatusType.WORKING_TREE?this.onDragWorkingTree(e):t===m.StatusType.INDEX?this.onDragIndex(e):t===m.StatusType.MERGE?this.onDragMerge(e):u.DRAG_OVER_REJECT},t.prototype.onDragWorkingTree=function(e){if(e instanceof h.StatusGroup){var t=e;return t.getType()===m.StatusType.INDEX?u.DRAG_OVER_ACCEPT_BUBBLE_DOWN:u.DRAG_OVER_REJECT}if(e instanceof h.FileStatus){var n=e;return n.getType()===m.StatusType.INDEX?u.DRAG_OVER_ACCEPT_BUBBLE_UP:u.DRAG_OVER_REJECT}return u.DRAG_OVER_REJECT},t.prototype.onDragIndex=function(e){if(e instanceof h.StatusGroup){var t=e;return t.getType()===m.StatusType.WORKING_TREE?u.DRAG_OVER_ACCEPT_BUBBLE_DOWN:u.DRAG_OVER_REJECT}if(e instanceof h.FileStatus){var n=e;return n.getType()===m.StatusType.WORKING_TREE?u.DRAG_OVER_ACCEPT_BUBBLE_UP:u.DRAG_OVER_REJECT}return u.DRAG_OVER_REJECT},t.prototype.onDragMerge=function(e){if(e instanceof h.StatusGroup){var t=e;return t.getType()===m.StatusType.INDEX?u.DRAG_OVER_ACCEPT_BUBBLE_DOWN:u.DRAG_OVER_REJECT}if(e instanceof h.FileStatus){var n=e;return n.getType()===m.StatusType.INDEX?u.DRAG_OVER_ACCEPT_BUBBLE_UP:u.DRAG_OVER_REJECT}return u.DRAG_OVER_REJECT},t.prototype.drop=function(e,t,n){var r,i=this,o=t.getData(),a=o[0];r=a instanceof h.StatusGroup?a.all():o;var s=n;s.getType()===m.StatusType.INDEX&&this.getAction(f.StageAction).run(r).done(null,function(e){return i.onError(e)}),s.getType()===m.StatusType.WORKING_TREE&&this.getAction(f.UnstageAction).run(r).done(null,function(e){return i.onError(e)})},t.prototype.onError=function(e){this.messageService.show(o.Error,e)},t=__decorate([__param(0,v.IInstantiationService),__param(1,b),__param(2,y.IMessageService)],t)}(T);t.DragAndDrop=A;var L=function(e){function t(t,n){e.call(this,{clickBehavior:d.ClickBehavior.ON_MOUSE_UP}),this.actionProvider=t,this.contextMenuService=n,this.downKeyBindings["Shift-UpArrow"]=this.onUp.bind(this),this.downKeyBindings["Shift-DownArrow"]=this.onDown.bind(this),this.downKeyBindings["Shift-PageUp"]=this.onPageUp.bind(this),this.downKeyBindings["Shift-PageDown"]=this.onPageDown.bind(this)}return __extends(t,e),t.prototype.onLeftClick=function(t,n,r){if(n instanceof h.StatusGroup)return r.preventDefault(),r.stopPropagation(),!0;if(r.shiftKey){var o=t.getFocus();if(!o||o instanceof h.StatusGroup)return;var a=o,s=n;if(a.getType()!==s.getType())return;return this.canSelect(t,n)&&(t.setFocus(n),t.isSelected(n)?t.deselectRange(a,s):t.selectRange(a,s)),void 0}return t.setFocus(n),(i.isMacintosh?r.metaKey:r.ctrlKey)?(this.canSelect(t,n)&&t.toggleSelection(n,{origin:"mouse",originalEvent:r}),void 0):e.prototype.onLeftClick.call(this,t,n,r)},t.prototype.onEnter=function(t,n){var r=t.getFocus();return r instanceof h.StatusGroup?(n.preventDefault(),n.stopPropagation(),!0):e.prototype.onEnter.call(this,t,n)},t.prototype.onSpace=function(e,t){var n=e.getFocus();return n?this.canSelect(e,n)?(e.toggleSelection(n,{origin:"keyboard",originalEvent:t}),t.preventDefault(),t.stopPropagation(),!0):!1:(t.preventDefault(),t.stopPropagation(),!0)},t.prototype.onContextMenu=function(e,t,n){var r=this;if(n.target&&n.target.tagName&&"input"===n.target.tagName.toLowerCase())return!1;if(n.preventDefault(),n.stopPropagation(),e.setFocus(t),this.actionProvider.hasSecondaryActions(e,t)){var i={x:n.posx+1,y:n.posy},o={selection:e.getSelection(),focus:t};return this.contextMenuService.showContextMenu({getAnchor:function(){return i},getActions:function(){return r.actionProvider.getSecondaryActions(e,t)},getActionItem:this.actionProvider.getActionItem.bind(this.actionProvider,e,t),getActionsContext:function(){return o},onHide:function(t){t&&e.DOMFocus()}}),!0}return!1},t.prototype.onLeft=function(){return!0},t.prototype.onRight=function(){return!0},t.prototype.onUp=function(t,n){var r=t.getFocus(),i=e.prototype.onUp.call(this,t,n);return i&&n.shiftKey?this.shiftSelect(t,r,n):!1},t.prototype.onPageUp=function(t,n){var r=t.getFocus(),i=e.prototype.onPageUp.call(this,t,n);return i&&n.shiftKey?this.shiftSelect(t,r,n):!1},t.prototype.onDown=function(t,n){var r=t.getFocus(),i=e.prototype.onDown.call(this,t,n);return i&&n.shiftKey?this.shiftSelect(t,r,n):!1},t.prototype.onPageDown=function(t,n){var r=t.getFocus(),i=e.prototype.onPageDown.call(this,t,n);return i&&n.shiftKey?this.shiftSelect(t,r,n):!1},t.prototype.canSelect=function(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n];return t.some(function(e){return e instanceof h.StatusGroup})?!1:t.every(function(t){var n=e.getSelection()[0],r=t;return!n||n.getType()===r.getType()})},t.prototype.shiftSelect=function(e,t,n){var r={origin:"keyboard",originalEvent:n},i=e.getFocus();if(i===t)return!1;var o=e.isSelected(t),a=e.isSelected(i);return o&&a?e.deselectRange(i,t,r):o||a?o?this.canSelect(e,i)&&e.selectRange(i,t,r):e.deselectRange(i,t,r):this.canSelect(e,t,i)&&e.selectRange(i,t,r),!0},t=__decorate([__param(1,g.IContextMenuService)],t)}(d.DefaultController);t.Controller=L}),define("vs/css!vs/workbench/parts/git/browser/views/changes/changesView",["vs/css!vs/workbench/parts/git/browser/gitViewlet"],{});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n},__decorate=this&&this.__decorate||function(e,t,n,r){if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)return Reflect.decorate(e,t,n,r);switch(arguments.length){case 2:return e.reduceRight(function(e,t){return t&&t(e)||e},t);case 3:return e.reduceRight(function(e,r){return r&&r(t,n),void 0},void 0);case 4:return e.reduceRight(function(e,r){return r&&r(t,n,e)||e},r)}},__param=this&&this.__param||function(e,t){return function(n,r){t(n,r,e)}};define("vs/workbench/parts/git/browser/views/changes/changesView",["require","exports","vs/nls!vs/workbench/parts/git/browser/gitViewlet","vs/base/common/platform","vs/base/common/lifecycle","vs/base/common/eventEmitter","vs/base/common/strings","vs/base/common/errors","vs/base/common/winjs.base","vs/base/browser/builder","vs/base/browser/keyboardEvent","vs/base/common/actions","vs/base/browser/ui/actionbar/actionbar","vs/base/parts/tree/browser/treeImpl","vs/workbench/browser/events","vs/workbench/parts/git/common/git","vs/workbench/parts/git/browser/gitActions","vs/workbench/parts/git/common/gitModel","vs/workbench/parts/git/browser/views/changes/changesViewer","vs/workbench/parts/git/browser/gitEditorInputs","vs/workbench/parts/files/common/files","vs/workbench/parts/output/common/output","vs/workbench/common/editor","vs/base/browser/ui/inputbox/inputBox","vs/base/common/severity","vs/workbench/services/editor/common/editorService","vs/platform/contextview/browser/contextView","vs/platform/instantiation/common/instantiation","vs/platform/message/browser/message","vs/platform/workspace/common/workspace","vs/platform/selection/common/selection","vs/platform/event/common/event","vs/css!./changesView"],function(e,t,n,r,i,o,a,s,c,l,u,p,d,m,h,f,g,v,y,_,b,E,T,S,k,C,w,x,A,L,N,P){var O=f.IGitService,I=l.$,M=function(e){function t(t,n,r,i,o,a,c,l,u){var p=this;e.call(this),this.ID="changes",this.instantiationService=n,this.editorService=r,this.messageService=i,this.contextViewService=o,this.contextService=a,this.gitService=c,this.outputService=l,this.visible=!1,this.currentDimension=null,this.actionRunner=t,this.toDispose=[this.smartCommitAction=this.instantiationService.createInstance(g.SmartCommitAction,this),u.addListener2(h.EventType.EDITOR_INPUT_CHANGED,function(e){return p.onEditorInputChanged(e.editorInput).done(null,s.onUnexpectedError)}),this.gitService.addListener2(f.ServiceEvents.OPERATION_START,function(e){return p.onGitOperationStart(e)}),this.gitService.addListener2(f.ServiceEvents.OPERATION_END,function(e){return p.onGitOperationEnd(e)}),this.gitService.getModel().addListener2(f.ModelEvents.MODEL_UPDATED,this.onGitModelUpdate.bind(this))]}return __extends(t,e),Object.defineProperty(t.prototype,"element",{get:function(){return this.render(),this.$el.getHTMLElement()},enumerable:!0,configurable:!0}),t.prototype.render=function(){var e=this;if(!this.$el){this.$el=I(".changes-view"),this.$commitView=I(".commit-view").appendTo(this.$el),this.commitInputBox=new S.InputBox(this.$commitView.getHTMLElement(),this.contextViewService,{placeholder:n.localize("vs_workbench_parts_git_browser_views_changes_changesView",0,t.COMMIT_KEYBINDING),validationOptions:{showMessage:!0,validation:function(){return null}},flexibleHeight:!0}),this.addEmitter2(this.commitInputBox,"commitInputBox"),I(this.commitInputBox.inputElement).on("keydown",function(n){var i=new u.KeyboardEvent(n),o=i.asString();(r.isMacintosh?["Meta-S","Meta-Enter"]:["Ctrl-S","Ctrl-Enter"]).indexOf(o)>-1&&(e.smartCommitAction.enabled?e.actionRunner.run(e.smartCommitAction).done():e.commitInputBox.showMessage({content:t.NOTHING_TO_COMMIT,formatContent:!0,type:S.MessageType.INFO}))}).on("blur",function(){e.commitInputBox.hideMessage()}),this.$statusView=I(".status-view").appendTo(this.$el);var i=this.instantiationService.createInstance(y.ActionProvider),o=this.instantiationService.createInstance(y.Renderer,i,this.actionRunner),a=this.instantiationService.createInstance(y.DragAndDrop),s=this.instantiationService.createInstance(y.Controller,i);this.tree=new m.Tree(this.$statusView.getHTMLElement(),{dataSource:new y.DataSource,renderer:o,filter:new y.Filter,sorter:new y.Sorter,dnd:a,controller:s},{indentPixels:0,twistiePixels:20}),this.tree.setInput(this.gitService.getModel().getStatus()),this.tree.expandAll(this.gitService.getModel().getStatus().getGroups()),this.toDispose.push(this.tree.addListener2("selection",function(t){return e.onSelection(t)})),this.toDispose.push(this.commitInputBox.addListener2("heightchange",function(){return e.layout()}))}},t.prototype.focus=function(){var e=this.tree.getSelection();e.length>0&&this.tree.reveal(e[0],.5),this.commitInputBox.focus()},t.prototype.layout=function(e){if(void 0===e&&(e=this.currentDimension),e){this.currentDimension=e;var t=e.height-(this.commitInputBox.height+10);this.$statusView.size(e.width,t),this.tree.layout(t),134===this.commitInputBox.height?this.$commitView.addClass("scroll"):this.$commitView.removeClass("scroll")}},t.prototype.setVisible=function(e){return this.visible=e,e?(this.tree.onVisible(),this.onEditorInputChanged(this.editorService.getActiveEditorInput())):(this.tree.onHidden(),c.Promise.as(null))},t.prototype.getSelection=function(){return new N.StructuredSelection(this.tree.getSelection())},t.prototype.getControl=function(){return this.tree},t.prototype.getActions=function(){var e=this;return this.actions||(this.actions=[this.smartCommitAction,this.instantiationService.createInstance(g.RefreshAction)],this.actions.forEach(function(t){return e.toDispose.push(t)})),this.actions},t.prototype.getSecondaryActions=function(){var e=this;return this.secondaryActions||(this.secondaryActions=[this.instantiationService.createInstance(g.SyncAction),this.instantiationService.createInstance(g.PullAction),this.instantiationService.createInstance(g.PushAction),new d.Separator,this.instantiationService.createInstance(g.CommitAction,this),this.instantiationService.createInstance(g.StageAndCommitAction,this),new d.Separator,this.instantiationService.createInstance(g.GlobalUnstageAction),this.instantiationService.createInstance(g.GlobalUndoAction),new d.Separator,new p.Action("show.gitOutput",n.localize("vs_workbench_parts_git_browser_views_changes_changesView",1),null,!0,function(){return e.outputService.showOutput("Git")})],this.secondaryActions.forEach(function(t){return e.toDispose.push(t)})),this.secondaryActions},t.prototype.getCommitMessage=function(){return a.trim(this.commitInputBox.value)},t.prototype.onEmptyCommitMessage=function(){this.commitInputBox.focus(),this.commitInputBox.showMessage({content:t.NEED_MESSAGE,formatContent:!0,type:S.MessageType.INFO})},t.prototype.onGitModelUpdate=function(){var e=this;this.tree&&this.tree.refresh().done(function(){return e.tree.expandAll(e.gitService.getModel().getStatus().getGroups())})},t.prototype.onEditorInputChanged=function(e){var t=this;if(!this.tree)return c.Promise.as(null);var n=this.getStatusFromInput(e);return n||(this.tree.clearSelection(),this.tree.clearFocus()),this.visible&&-1===this.tree.getSelection().indexOf(n)?this.tree.reveal(n,.5).then(function(){t.tree.setSelection([n],{origin:"implicit"}),t.tree.setFocus(n)}):c.Promise.as(null)},t.prototype.onSelection=function(e){var t=this;if(!(e.payload&&e.payload&&"implicit"===e.payload.origin||1!==e.selection.length)){var n=e.selection[0];if(n instanceof v.FileStatus&&(!e.payload||"keyboard"!==e.payload.origin||"Enter"===e.payload.originalEvent.asString())){var r=e.payload&&"mouse"===e.payload.origin;if(!r||!e.payload.originalEvent.metaKey&&!e.payload.originalEvent.shiftKey){var i=n;this.gitService.getInput(i).done(function(n){var i=new T.TextDiffEditorOptions;r&&(i.preserveFocus=!0),i.forceOpen=!0;var o=e&&e.payload&&e.payload.originalEvent&&e.payload.originalEvent.altKey;return t.editorService.openEditor(n,i,o)},function(e){return e.gitErrorCode===f.GitErrorCodes.CantOpenResource?(t.messageService.show(k.Warning,e),void 0):(t.messageService.show(k.Error,e),void 0)})}}}},t.prototype.onGitOperationStart=function(e){e.id===f.ServiceOperations.COMMIT&&this.commitInputBox&&this.commitInputBox.disable()},t.prototype.onGitOperationEnd=function(e){e.operation.id===f.ServiceOperations.COMMIT&&this.commitInputBox&&(this.commitInputBox.enable(),e.error||(this.commitInputBox.value=""))},t.prototype.getStatusFromInput=function(e){if(!e)return null;if(e instanceof _.GitDiffEditorInput)return e.getFileStatus();if(e instanceof _.GitIndexEditorInput)return e.getFileStatus()||null;if(e instanceof _.NativeGitIndexStringEditorInput)return e.getFileStatus()||null;if(e instanceof b.FileEditorInput){var t=e,n=this.contextService.toWorkspaceRelativePath(t.getResource());if(!n)return null;var r=this.gitService.getModel().getStatus().getWorkingTreeStatus().find(n);if(r&&(r.getStatus()===f.Status.UNTRACKED||r.getStatus()===f.Status.IGNORED))return r;if(r=this.gitService.getModel().getStatus().getMergeStatus().find(n))return r}return null},t.prototype.dispose=function(){this.$el&&(this.$el.dispose(),this.$el=null),this.toDispose=i.disposeAll(this.toDispose),e.prototype.dispose.call(this)},t.COMMIT_KEYBINDING=r.isMacintosh?"Cmd+Enter":"Ctrl+Enter",t.NEED_MESSAGE=n.localize("vs_workbench_parts_git_browser_views_changes_changesView",2,t.COMMIT_KEYBINDING),t.NOTHING_TO_COMMIT=n.localize("vs_workbench_parts_git_browser_views_changes_changesView",3,t.COMMIT_KEYBINDING),t=__decorate([__param(1,x.IInstantiationService),__param(2,C.IWorkbenchEditorService),__param(3,A.IMessageService),__param(4,w.IContextViewService),__param(5,L.IWorkspaceContextService),__param(6,O),__param(7,E.IOutputService),__param(8,P.IEventService)],t)}(o.EventEmitter);t.ChangesView=M}),define("vs/css!vs/workbench/parts/git/browser/views/empty/emptyView",["vs/css!vs/workbench/parts/git/browser/gitViewlet"],{});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n},__decorate=this&&this.__decorate||function(e,t,n,r){if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)return Reflect.decorate(e,t,n,r);switch(arguments.length){case 2:return e.reduceRight(function(e,t){return t&&t(e)||e},t);case 3:return e.reduceRight(function(e,r){return r&&r(t,n),void 0},void 0);case 4:return e.reduceRight(function(e,r){return r&&r(t,n,e)||e},r)}},__param=this&&this.__param||function(e,t){return function(n,r){t(n,r,e)}};define("vs/workbench/parts/git/browser/views/empty/emptyView",["require","exports","vs/nls!vs/workbench/parts/git/browser/gitViewlet","vs/base/common/lifecycle","vs/base/common/eventEmitter","vs/base/browser/dom","vs/base/common/winjs.base","vs/base/browser/builder","vs/workbench/parts/git/common/git","vs/workbench/parts/git/browser/gitActions","vs/base/common/severity","vs/platform/files/common/files","vs/platform/instantiation/common/instantiation","vs/platform/message/browser/message","vs/platform/selection/common/selection","vs/css!./emptyView"],function(e,t,n,r,i,o,a,s,c,l,u,p,d,m,h){var f=c.IGitService,g=s.$,v=function(e){function t(t){var n=this;e.call(this),this.$el=g("a.button.clone").href("#").appendTo(t),this.$el.on("click",function(e){return n.enabled?(n.emit("click",e),void 0):(o.EventHelper.stop(e),void 0)})}return __extends(t,e),Object.defineProperty(t.prototype,"label",{set:function(e){this.$el.text(e)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"enabled",{get:function(){return!this.$el.hasClass("disabled")},set:function(e){e?this.$el.removeClass("disabled"):this.$el.addClass("disabled")},enumerable:!0,configurable:!0}),t.prototype.dispose=function(){this.$el&&(this.$el.dispose(),this.$el=null),e.prototype.dispose.call(this)},t}(i.EventEmitter);t.Button=v;var y=function(e){function t(t,n,r,i,o,a){e.call(this),this.ID="empty",this.gitService=r,this.instantiationService=i,this.messageService=o,this.fileService=a,this.actionRunner=n,this.isVisible=!1,this.needsRender=!1,this.controller=t,this.toDispose=[]}return __extends(t,e),Object.defineProperty(t.prototype,"initAction",{get:function(){return this._initAction||(this._initAction=this.instantiationService.createInstance(l.InitAction)),this._initAction},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"element",{get:function(){return this.render(),this.$el.getHTMLElement()},enumerable:!0,configurable:!0}),t.prototype.render=function(){var e=this;if(!this.$el){this.$el=g(".empty-view"),g("p").appendTo(this.$el).text(t.EMPTY_MESSAGE);var r=g(".section").appendTo(this.$el);this.initButton=new v(r),this.initButton.label=n.localize("vs_workbench_parts_git_browser_views_empty_emptyView",0),this.initButton.on("click",function(t){o.EventHelper.stop(t),e.disableUI(),e.actionRunner.run(e.initAction).done(function(){e.enableUI()})}),this.toDispose.push(this.gitService.addListener2(c.ServiceEvents.OPERATION,function(){return e.onGitOperation()}))}},t.prototype.disableUI=function(){this.urlInputBox&&this.urlInputBox.disable(),this.cloneButton&&(this.cloneButton.enabled=!1),this.initButton.enabled=!1},t.prototype.enableUI=function(){this.gitService.getRunningOperations().length>0||(this.urlInputBox&&(this.urlInputBox.enable(),this.urlInputBox.validate()),this.initButton.enabled=!0)},t.prototype.onError=function(e){this.messageService.show(u.Error,e)},t.prototype.focus=function(){},t.prototype.layout=function(){},t.prototype.setVisible=function(e){return this.isVisible=e,a.Promise.as(null)},t.prototype.getSelection=function(){return h.Selection.EMPTY},t.prototype.getControl=function(){return null},t.prototype.getActions=function(){return this.refreshAction?[this.refreshAction]:[]},t.prototype.getSecondaryActions=function(){return[]},t.prototype.onGitOperation=function(){this.gitService.getRunningOperations().length>0?this.disableUI():this.enableUI()},t.prototype.dispose=function(){this.$el&&(this.$el.dispose(),this.$el=null),this.toDispose=r.disposeAll(this.toDispose),e.prototype.dispose.call(this)},t.EMPTY_MESSAGE=n.localize("vs_workbench_parts_git_browser_views_empty_emptyView",1),t=__decorate([__param(2,f),__param(3,d.IInstantiationService),__param(4,m.IMessageService),__param(5,p.IFileService)],t)}(i.EventEmitter);t.EmptyView=y}),define("vs/css!vs/workbench/parts/git/browser/views/gitless/gitlessView",["vs/css!vs/workbench/parts/git/browser/gitViewlet"],{});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n},__decorate=this&&this.__decorate||function(e,t,n,r){if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)return Reflect.decorate(e,t,n,r);switch(arguments.length){case 2:return e.reduceRight(function(e,t){return t&&t(e)||e},t);case 3:return e.reduceRight(function(e,r){return r&&r(t,n),void 0},void 0);case 4:return e.reduceRight(function(e,r){return r&&r(t,n,e)||e},r)}},__param=this&&this.__param||function(e,t){return function(n,r){t(n,r,e)}};define("vs/workbench/parts/git/browser/views/gitless/gitlessView",["require","exports","vs/nls!vs/workbench/parts/git/browser/gitViewlet","vs/base/common/platform","vs/base/common/winjs.base","vs/base/common/eventEmitter","vs/base/browser/builder","vs/platform/workspace/common/workspace","vs/platform/selection/common/selection","vs/css!./gitlessView"],function(e,t,n,r,i,o,a,s,c){var l=a.$,u=function(e){function t(t){e.call(this),this.ID="gitless",this._contextService=t}return __extends(t,e),Object.defineProperty(t.prototype,"element",{get:function(){return this._element||this.render(),this._element},enumerable:!0,configurable:!0}),t.prototype.render=function(){var e;e=r.isMacintosh?n.localize("vs_workbench_parts_git_browser_views_gitless_gitlessView",0,'<a href="http://brew.sh/" target="_blank">Homebrew</a>','<a href="http://git-scm.com/download/mac" target="_blank">git-scm.com</a>','<a href="https://developer.apple.com/xcode/" target="_blank">XCode</a>',"<code>git</code>"):r.isWindows?n.localize("vs_workbench_parts_git_browser_views_gitless_gitlessView",1,'<a href="https://chocolatey.org/packages/git" target="_blank">Chocolatey</a>','<a href="http://git-scm.com/download/win" target="_blank">git-scm.com</a>'):r.isLinux?n.localize("vs_workbench_parts_git_browser_views_gitless_gitlessView",2,'<a href="http://git-scm.com/download/linux" target="_blank">git-scm.com</a>'):n.localize("vs_workbench_parts_git_browser_views_gitless_gitlessView",3,'<a href="http://git-scm.com/download" target="_blank">git-scm.com</a>'),this._element=l(['<div class="gitless-view">',"<p>",n.localize("vs_workbench_parts_git_browser_views_gitless_gitlessView",4),"</p>","<p>",e,"</p>","<p>",n.localize("vs_workbench_parts_git_browser_views_gitless_gitlessView",5,this._contextService.getConfiguration().env.appName),"</p>","</div>"].join("")).getHTMLElement()},t.prototype.focus=function(){},t.prototype.layout=function(){},t.prototype.setVisible=function(){return i.Promise.as(null)},t.prototype.getSelection=function(){return c.Selection.EMPTY},t.prototype.getControl=function(){return null},t.prototype.getActions=function(){return[]},t.prototype.getSecondaryActions=function(){return[]},t=__decorate([__param(0,s.IWorkspaceContextService)],t)}(o.EventEmitter);t.GitlessView=u}),define("vs/css!vs/workbench/parts/git/browser/views/notroot/notrootView",["vs/css!vs/workbench/parts/git/browser/gitViewlet"],{});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/workbench/parts/git/browser/views/notroot/notrootView",["require","exports","vs/nls!vs/workbench/parts/git/browser/gitViewlet","vs/base/common/winjs.base","vs/base/common/eventEmitter","vs/base/browser/builder","vs/platform/selection/common/selection","vs/css!./notrootView"],function(e,t,n,r,i,o,a){var s=o.$,c=function(e){function t(){e.apply(this,arguments),this.ID="notroot"}return __extends(t,e),Object.defineProperty(t.prototype,"element",{get:function(){return this._element||this.render(),this._element},enumerable:!0,configurable:!0}),t.prototype.render=function(){this._element=s(['<div class="notroot-view">',"<p>",n.localize("vs_workbench_parts_git_browser_views_notroot_notrootView",0),"</p>","<p>",n.localize("vs_workbench_parts_git_browser_views_notroot_notrootView",1),"</p>","</div>"].join("")).getHTMLElement()},t.prototype.focus=function(){},t.prototype.layout=function(){},t.prototype.setVisible=function(){return r.Promise.as(null)},t.prototype.getSelection=function(){return a.Selection.EMPTY},t.prototype.getControl=function(){return null},t.prototype.getActions=function(){return[]},t.prototype.getSecondaryActions=function(){return[]},t}(i.EventEmitter);t.NotRootView=c}),define("vs/css!vs/workbench/parts/git/browser/views/noworkspace/noworkspaceView",["vs/css!vs/workbench/parts/git/browser/gitViewlet"],{});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/workbench/parts/git/browser/views/noworkspace/noworkspaceView",["require","exports","vs/nls!vs/workbench/parts/git/browser/gitViewlet","vs/base/common/winjs.base","vs/base/common/eventEmitter","vs/base/browser/builder","vs/platform/selection/common/selection","vs/css!./noworkspaceView"],function(e,t,n,r,i,o,a){var s=o.$,c=function(e){function t(){e.apply(this,arguments),this.ID="noworkspace"}return __extends(t,e),Object.defineProperty(t.prototype,"element",{get:function(){return this._element||this.render(),this._element},enumerable:!0,configurable:!0}),t.prototype.render=function(){this._element=s(['<div class="noworkspace-view">',"<p>",n.localize("vs_workbench_parts_git_browser_views_noworkspace_noworkspaceView",0),"</p>","<p>",n.localize("vs_workbench_parts_git_browser_views_noworkspace_noworkspaceView",1),"</p>","</div>"].join("")).getHTMLElement()},t.prototype.focus=function(){},t.prototype.layout=function(){},t.prototype.setVisible=function(){return r.Promise.as(null)},t.prototype.getSelection=function(){return a.Selection.EMPTY},t.prototype.getControl=function(){return null},t.prototype.getActions=function(){return[]},t.prototype.getSecondaryActions=function(){return[]},t}(i.EventEmitter);t.NoWorkspaceView=c}),define("vs/css!vs/workbench/parts/git/browser/media/gitViewlet",["vs/css!vs/workbench/parts/git/browser/gitViewlet"],{});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n},__decorate=this&&this.__decorate||function(e,t,n,r){if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)return Reflect.decorate(e,t,n,r);switch(arguments.length){case 2:return e.reduceRight(function(e,t){return t&&t(e)||e},t);case 3:return e.reduceRight(function(e,r){return r&&r(t,n),void 0},void 0);case 4:return e.reduceRight(function(e,r){return r&&r(t,n,e)||e},r)}},__param=this&&this.__param||function(e,t){return function(n,r){t(n,r,e)}};define("vs/workbench/parts/git/browser/gitViewlet",["require","exports","vs/base/common/winjs.base","vs/base/common/lifecycle","vs/workbench/browser/ui/viewlet","vs/workbench/parts/git/common/git","vs/workbench/parts/git/browser/gitWorkbenchContributions","vs/workbench/parts/git/browser/views/changes/changesView","vs/workbench/parts/git/browser/views/empty/emptyView","vs/workbench/parts/git/browser/views/gitless/gitlessView","vs/workbench/parts/git/browser/views/notroot/notrootView","vs/workbench/parts/git/browser/views/noworkspace/noworkspaceView","vs/platform/instantiation/common/instantiation","vs/platform/progress/common/progress","vs/platform/selection/common/selection","vs/platform/telemetry/common/telemetry","vs/css!./media/gitViewlet"],function(e,t,n,r,i,o,a,s,c,l,u,p,d,m,h,f){var g=o.IGitService,v=function(e){function t(t,n,r,i){var o=this;e.call(this,a.VIEWLET_ID,t),this.progressService=n,this.instantiationService=r,this.gitService=i,this.progressRunner=null,this.views={},this.toDispose=[];var d=[this.instantiationService.createInstance(s.ChangesView,this.getActionRunner()),this.instantiationService.createInstance(c.EmptyView,this,this.getActionRunner()),this.instantiationService.createInstance(l.GitlessView),new u.NotRootView,new p.NoWorkspaceView];d.forEach(function(e){o.views[e.ID]=e,o.toDispose.push(e)}),this.toUnbind.push(this.gitService.addBulkListener(function(){return o.onGitServiceChanges()}))}return __extends(t,e),t.prototype.setView=function(e){if(!this.$el)return n.Promise.as(null);var t=this.views[e];if(!t)return n.Promise.wrapError(new Error("Could not find view."));if(this.currentView===t)return n.Promise.as(null);var r=n.Promise.as(null);this.currentView&&(r=this.currentView.setVisible(!1));var i=t.element;this.currentView=t,this.updateTitleArea();for(var o=this.$el.getHTMLElement();o.firstChild;)o.removeChild(o.firstChild);return o.appendChild(i),t.layout(this.currentDimension),r.then(function(){return t.setVisible(!0)})},t.prototype.create=function(t){return e.prototype.create.call(this,t),this.$el=t.div().addClass("git-viewlet"),n.Promise.as(null)},t.prototype.setVisible=function(t){var r=this;return t?(this.onGitServiceChanges(),this.gitService.status().done(),e.prototype.setVisible.call(this,t).then(function(){return r.currentView?r.currentView.setVisible(t):void 0})):(this.currentView?this.currentView.setVisible(t):n.Promise.as(null)).then(function(){e.prototype.setVisible.call(r,t)})},t.prototype.focus=function(){e.prototype.focus.call(this),this.currentView&&this.currentView.focus()},t.prototype.layout=function(t){void 0===t&&(t=this.currentDimension),e.prototype.layout.call(this,t),this.currentDimension=t,this.currentView&&this.currentView.layout(t)},t.prototype.getActions=function(){return this.currentView?this.currentView.getActions():[]},t.prototype.getSecondaryActions=function(){return this.currentView?this.currentView.getSecondaryActions():[]},t.prototype.getSelection=function(){return this.currentView?this.currentView.getSelection():h.Selection.EMPTY},t.prototype.getControl=function(){return this.currentView?this.currentView.getControl():null
},t.prototype.onGitServiceChanges=function(){this.progressRunner&&this.progressRunner.done(),this.gitService.getState()===o.ServiceState.NoGit?(this.setView("gitless"),this.progressRunner=null):this.gitService.getState()===o.ServiceState.NotARepo?(this.setView("empty"),this.progressRunner=null):this.gitService.getState()===o.ServiceState.NotAWorkspace?(this.setView("noworkspace"),this.progressRunner=null):this.gitService.getState()===o.ServiceState.NotAtRepoRoot?(this.setView("notroot"),this.progressRunner=null):this.gitService.isIdle()?(this.setView("changes"),this.progressRunner=null):this.progressRunner=this.progressService.show(!0)},t.prototype.dispose=function(){this.toDispose=r.disposeAll(this.toDispose),this.views=null,e.prototype.dispose.call(this)},t=__decorate([__param(0,f.ITelemetryService),__param(1,m.IProgressService),__param(2,d.IInstantiationService),__param(3,g)],t)}(i.Viewlet);t.GitViewlet=v});